import { PluginDefinition, IPluginSource } from 'zox-plugins';
export declare type MaybeDeepArray<T> = T | T[] | T[][] | T[][][];
export interface TypeDefsOptions {
    typeDefs?: MaybeDeepArray<string>;
}
export declare abstract class TypeDefsPluginManager<TPlugin, TData> {
    protected readonly pluginKey: symbol;
    protected readonly pluginDefinitions: Array<PluginDefinition<TPlugin, TData & TypeDefsOptions>>;
    constructor(pluginDiscovery: IPluginSource);
    getTypeDefList(): Array<string>;
}
