"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class TypeDefsPluginManager {
    constructor(pluginDiscovery) {
        this.pluginDefinitions = pluginDiscovery.getPlugins(this.pluginKey);
    }
    get pluginKey() { return undefined; }
    getTypeDefList() {
        const typeDefs = [];
        for (const pluginDefinition of this.pluginDefinitions) {
            flatForEach(pluginDefinition.data.typeDefs, typeDef => {
                if (typeDefs.indexOf(typeDef) < 0) {
                    typeDefs.push(typeDef);
                }
            });
        }
        return typeDefs;
    }
}
exports.TypeDefsPluginManager = TypeDefsPluginManager;
function flatForEach(arr, callback) {
    if ((Array.isArray(arr))) {
        for (const item of arr) {
            flatForEach(item, callback);
        }
    }
    else {
        callback(arr);
    }
}
//# sourceMappingURL=TypeDefsPluginManager.js.map