"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ScalarPluginManager_1 = require("../PluginManagers/ScalarPluginManager");
const graphql_1 = require("graphql");
const AnyScalar_1 = require("./AnyScalar");
let ObjectScalar = class ObjectScalar {
    constructor() {
        this.serialize = ensureObject;
        this.parseValue = ensureObject;
    }
    parseLiteral(ast, variables) {
        if (ast.kind === graphql_1.Kind.OBJECT) {
            return AnyScalar_1.parseObject(ast, variables);
        }
    }
};
ObjectScalar = __decorate([
    ScalarPluginManager_1.PureScalar('Object')
], ObjectScalar);
exports.ObjectScalar = ObjectScalar;
function ensureObject(value) {
    if (typeof value !== 'object' || value === null || Array.isArray(value)) {
        throw new TypeError(`Object cannot represent non-object value: '${value}'`);
    }
    return value;
}
//# sourceMappingURL=ObjectScalar.js.map