"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
function createSubscriptionFeed(args, feedHandler) {
    return graphql_1.subscribe(args).then((subscription) => {
        console.log('subscribed');
        const handleNext = next => {
            feedHandler(next);
            if (!next.done) {
                subscription.next().then(handleNext);
            }
        };
        subscription.next().then(handleNext);
        return subscription.return.bind(subscription);
    });
}
exports.createSubscriptionFeed = createSubscriptionFeed;
//# sourceMappingURL=SubscriptionFeed.js.map