"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
class SubscriptionManager {
    constructor(schema) {
        this.subscriptions = [];
        this.schema = schema;
    }
    subscribe(args, feedHandler) {
        args.schema = this.schema;
        return graphql_1.subscribe(args)
            .then((subscription) => {
            console.log('subscribed');
            const handleNext = next => {
                feedHandler(next);
                if (!next.done) {
                    subscription.next().then(handleNext);
                }
            };
            subscription.next().then(handleNext);
            this.subscriptions.push(subscription);
            return () => {
                const index = this.subscriptions.indexOf(subscription);
                const exists = index >= 0;
                if (exists) {
                    subscription.return();
                    this.subscriptions.splice(index, 1);
                }
                return exists;
            };
        });
    }
    unsubscribeAll() {
        for (const subscription of this.subscriptions) {
            subscription.return();
        }
        this.subscriptions.length = 0;
    }
}
exports.SubscriptionManager = SubscriptionManager;
//# sourceMappingURL=SubscriptionManager.js.map