import { IPluginSource } from 'zox-plugins';
import { GraphQLSchema } from 'graphql';
import { ResolverBuildOptions } from './PluginManagers/ResolverPluginManager';
import { IResolvers } from './Interfaces';
export interface AssembledSchema extends AssembledSchemaData {
    schema: GraphQLSchema;
}
export interface AssembledSchemaData {
    typeDefs: string;
    resolvers: IResolvers;
}
export declare function assembleSchema(pluginDiscovery: IPluginSource, options?: ResolverBuildOptions): AssembledSchema;
export declare function assembleSchemaData(pluginDiscovery: IPluginSource, options?: ResolverBuildOptions): AssembledSchemaData;
export declare function joinDistinct(typeDefLists: string[][]): string;
export declare function mergeResolvers(...resolversArr: IResolvers[]): IResolvers;
